const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const lesson_variants = sequelize.define(
    'lesson_variants',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

functional_role: {
        type: DataTypes.ENUM,
      
      

        values: [

"product_manager",


"marketing",


"sales",


"operations",


"executive",


"other"

        ],

      },

adapted_content: {
        type: DataTypes.TEXT,
      
      

      },

adaptation_notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  lesson_variants.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

































//end loop



    db.lesson_variants.belongsTo(db.lessons, {
      as: 'lesson',
      foreignKey: {
        name: 'lessonId',
      },
      constraints: false,
    });

    db.lesson_variants.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.lesson_variants.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.lesson_variants.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return lesson_variants;
};


